// pca.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "pca.h"

#include "mainfrm.h"
#include "pcaview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

CMainFrame	*pMainWnd;
CPcaApp		*gApplication;		

extern "C" extern void WINAPI InitPcaDLLD();

/////////////////////////////////////////////////////////////////////////////
// CPcaApp

BEGIN_MESSAGE_MAP(CPcaApp, CWinApp)
	//{{AFX_MSG_MAP(CPcaApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_QUIT, OnFileQuit)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPcaApp construction

CPcaApp::CPcaApp()
	{
	
	}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPcaApp object

CPcaApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CPcaApp initialization

BOOL CPcaApp::InitInstance()
	{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	AddDocTemplate(new CSingleDocTemplate(IDR_MAINFRAME,
			RUNTIME_CLASS(CPcaDoc),
			RUNTIME_CLASS(CMainFrame),     // main SDI frame window
			RUNTIME_CLASS(CPcaView)));

	pMainWnd = (CMainFrame *)m_pMainWnd;
	gApplication = this;
	
	//OnFileNew();

	//m_pDoc = (CPcaDoc*)m_templateList.GetHead();
	CDocTemplate* pTemplate = (CDocTemplate*)m_templateList.GetHead();
	ASSERT(pTemplate != NULL);
	ASSERT(pTemplate->IsKindOf(RUNTIME_CLASS(CDocTemplate)));
	m_pDoc = (CPcaDoc*)pTemplate->OpenDocumentFile(NULL);
   
	if (m_lpCmdLine[0] != '\0')
		{
		m_pDoc->SetFileName(m_lpCmdLine);
		}
   else
   	m_pDoc->SetFileName("");
	
	m_pDoc->ProjectNew();  
	return TRUE;
	}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CPcaApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CPcaApp commands

void CPcaApp::OnFileQuit()
	{
	OnAppExit();
	}
