// pcadoc.h : interface of the CPcaDoc class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef PCADOC_H
#define PCADOC_H

/*#include <CDrawF.h>
#include <CDrawRec.h>*/
#include <caam.h>
#include <lvq.h>

class CPcaDoc : public CDocument
{
protected: // create from serialization only
	CPcaDoc();
	DECLARE_DYNCREATE(CPcaDoc)

// Attributes
public:

protected:
	CDrawFace 	*pViewTraining;
	CDrawFace 	*pViewEigen;
	CDrawReconstruction 	*pViewReconstruct;
	CDrawReconstruction 	*pViewRecognize;
	CViewSammon	*pViewSammon;
	CAAM 			*pAAM;
	BOOL			bViewTraining;
	BOOL			bViewEigen;
	BOOL			bViewReconstruct;
	BOOL			bViewRecognize;
	BOOL			bViewSammon;
	char 			filename[128];
	
// Operations
public:

// Implementation
public:
	virtual ~CPcaDoc();
	virtual void Serialize(CArchive& ar);	// overridden for document i/o
#ifdef _DEBUG
	virtual	void AssertValid() const;
	virtual	void Dump(CDumpContext& dc) const;
#endif

	void ProjectNew();
	void SetMsg(char *msg);
	int  SaveReport(char *filename);
	void SetFileName(char *fn);
		
protected:
	virtual	BOOL	OnNewDocument();

// Generated message map functions
protected:
	//{{AFX_MSG(CPcaDoc)
	afx_msg void OnUpdateViewEigenfaces(CCmdUI* pCmdUI);
	afx_msg void OnViewEigenfaces();
	afx_msg void OnUpdateViewRecognizedfaces(CCmdUI* pCmdUI);
	afx_msg void OnViewRecognizedfaces();
	afx_msg void OnViewReconstructedfaces();
	afx_msg void OnUpdateViewReconstructedfaces(CCmdUI* pCmdUI);
	afx_msg void OnViewTrainingfaces();
	afx_msg void OnUpdateViewTrainingfaces(CCmdUI* pCmdUI);
	afx_msg void OnViewSammon();
	afx_msg void OnUpdateViewSammon(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

BOOL DoesWndExist(CWnd *pWnd);

#endif /* PCADOC_H */
/////////////////////////////////////////////////////////////////////////////
