// pcaview.h : interface of the CPcaView class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef PCAVIEW_H
#define PCAVIEW_H

#include "CMemory.h"
#include "pcadll.h"

class CPcaView : public CView
{
	protected: // create from serialization only
		CPcaView();
		DECLARE_DYNCREATE(CPcaView)
		BOOL PreCreateWindow(CREATESTRUCT &cs);
			
	// Attributes
	public:
		CPcaDoc* GetDocument();

// Operations
	public:
		void 		AppendMsg(char *str);
		int 		Save(char *filename);
		
	private:
		void 		DrawLine(long Line, CDC *pDC = NULL);
		void 		DrawCharLine(long lPos);
		int		GetCharHeight();
		int		GetCharWidth();
		long 		GetLineNumber(long lPos);
		
		CMemory		*pMem;					/*CMemory object storing the characters*/
		char 			*pText;					/*pointer to the data of pMem when it's locked*/
		long			lReportLen;				/*Length of the report in characters*/
		long			lLine;					/*Number of lines*/
		CDWordArray	*pLineArray;			/*The lth element contain the position of the first character of the lth line in pText*/
      
      int 			nVPos;					/*number of lines scrolled verticaly*/
      int			nHPos;               /*number of characters scrolled horizontaly*/
      
		HFONT 		hfont, hfontOld;		/*Character font*/
		int 			MapModePrevious;
      
	// Implementation
	public:
		virtual ~CPcaView();
		void 		OnDraw(CDC *pDC);
	#ifdef _DEBUG
		virtual void AssertValid() const;
		virtual void Dump(CDumpContext& dc) const;
	#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CPcaView)
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnDestroy();
	afx_msg LRESULT OnPutInfo(WPARAM wParam, LPARAM str_Info);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG	// debug version in pcaview.cpp
inline CPcaDoc* CPcaView::GetDocument()
   { return (CPcaDoc*) m_pDocument; }
#endif

#endif /*PCAVIEW_H*/

/////////////////////////////////////////////////////////////////////////////
