#ifndef CDRAWF_H
#define CDRAWF_H

#include "CFaceDB.h"
#include "def.h"
#include "CDiag.h"

class CDrawFace : public CFrameWnd
	{
	private:
		CFaceDB 			*pFaceDB;							/*Face DataBase data*/
		CMatrix 			*pFaceMat;
		CDiag 			*pEigenVal;
		char 				bMat;
		GEOMPARAMS 		gp;
		
		int				nMaxVPos;
		int				nVPos;
			
		HFONT 		hfont, hfontOld;		/*Character font*/
		int 			MapModePrevious;

	public:
		CDrawFace();
		
		void				SetFaceDB(CFaceDB *pFaceDBt);
		void				SetFaceDB(CMatrix *pFaceMatt);
		void				SetFaceDB(CMatrix *pFaceMatt, CDiag *pEigenValt);
		void				GetGeomParams(GEOMPARAMS *gp);
		int				Getxlen();
		int				Getylen();
	
	private:
		void				GetCornerFace(CORNER *c, long nFace);
		void				GetCornerName(CORNER *c, long nFace);

	// Generated message map functions
protected:
	//{{AFX_MSG(CWndFace)
	afx_msg void OnPaint();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	};

#endif /* CDRAWF_H */
