/******************************************************************************
 CMain.cp
				CMain Document Class
	
	Copyright  1996 Sami Romdhani All rights reserved.
	Generated by Visual Architect 12:10 pm Sat, Jan 27, 1996
	This file is only generated once. You can modify it by filling
	in the placeholder functions and adding any new functions you wish.
	If you change the name of the document class, a fresh version of this
	file will be generated. If you have made any changes to the file
	with the old name, you will have to copy those changes to the new
	file by hand.
 ******************************************************************************/
#include "CMain.h"
#include "CFaceDB.h"
#include "AppCommands.h"			// Remove comments if DoCommand overridden
#include <CApplication.h>
#include <CBartender.h>
#include <Commands.h>
#include <Constants.h>
#include <CDecorator.h>
#include <CDesktop.h>
#include <CFile.h>
#include <TBUtilities.h>
#include <CWindow.h>
#include <stdlib.h>
#include <ctype.h>
#include "utilcpp.h"
#include "str.h"
#include "error.h"
extern CApplication *gApplication;		/* The application					*/
extern CDecorator	*gDecorator;		/* Decorator for arranging windows	*/
extern CDesktop		*gDesktop;			/* The visible Desktop				*/
extern CBartender	*gBartender;		/* Manages all menus				*/
CDocument *pDoc;
TCL_DEFINE_CLASS_M1(CMain, x_CMain);
/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/
/******************************************************************************
 ICMain
	Initialize the document
 ******************************************************************************/
void CMain::ICMain()
	{
	int i;
	
	Ix_CMain();
	bViewTraining = FALSE;
	bViewEigen = FALSE;
	bViewReconstruction = FALSE;
	bViewRecognition = FALSE;
	pViewTraining = (CViewFaces*)NULL;
	pViewEigen = (CViewFaces*)NULL;
	pViewReconstruction = NULL;
	pViewRecognition = NULL;
	lenmsg = 0;
	pDoc = this;
	pAAM = NULL;
	pScrollP = NULL;
	pMainStat = NULL;
	
	for (i = 0; i < 15; i++)
		MoreMasters();								/*Reserves memory for the Application*/
	}
CMain::~CMain()
	{	TCL_START_DESTRUCTOR
	if (pMainStat != NULL)
		{
		/*delete*/ TCLForgetObject(pMainStat);
		}
	if (pScrollP != NULL)
		{
		/*delete*/ TCLForgetObject(pScrollP);
		}
#if 0
	if (bViewTraining == TRUE && pViewTraining != NULL)
		{
		TCLForgetObject(pViewTraining);
		}
	if (pViewEigen != NULL)
		{
		TCLForgetObject(pViewEigen);
		}
	if (pViewReconstruction != NULL)
		{
		TCLForgetObject(pViewReconstruction);
		}
	if (pViewRecognition != NULL)
		{
		TCLForgetObject(pViewRecognition);
		}
#endif
	if (pAAM != NULL)
		{
		delete pAAM;
		}
	}	
/******************************************************************************
 MakeNewContents
	Create "blank" document contents. MakeNewContents is called
	after itsWindow is created and before it is first selected,
	whether or not the document uses a file.
 ******************************************************************************/
void CMain::MakeNewContents()
	{
		// Initialize document contents and itsWindow here
	pScrollP = new CScrollPane((CView*)itsWindow, (CBureaucrat*)this, 0, 0, 0, 0, sizELASTIC, sizELASTIC, TRUE, TRUE, TRUE);
	pMainStat = new CReport((CView*)pScrollP, (CBureaucrat*)this);
	pScrollP->FitToEnclosure(TRUE, TRUE);
	pScrollP->InstallPanorama((CPanorama*)pMainStat);
	((CPanorama*)pMainStat)->SetScrollPane(pScrollP);
	((CPanorama*)pMainStat)->FitToEnclosure(TRUE, TRUE);
	lenmsg = 0;
	}
void CMain::NewFile(void)
	{
	x_CMain::NewFile();
	SFTypeList tl;
	StandardFileReply reply;
	CInfoPBRec myPB;
	char fullPath[500], dirName[255], temp[500];
	int n;
	OSErr oserr = 0;
	
	pAAM = new CAAM();							/*Construct the auto associative memory and its eigenvectors*/
//	strcpy(fullPath, (char const *)"Quadra 950:Development:Sami Romdhani MSc:Face DataBase:trial.pca");
	tl[0] = 'TEXT'; 
	StandardGetFile(NULL, 1, tl, &reply);
	if (reply.sfGood == TRUE && reply.sfIsFolder == FALSE && reply.sfIsVolume == FALSE)
		{
		strcpy(fullPath, (char const *)(reply.sfFile.name));		//initialize full pathname
		p2cstr((unsigned char *)fullPath);
		myPB.dirInfo.ioNamePtr = (unsigned char *)dirName;
		myPB.dirInfo.ioVRefNum = reply.sfFile.vRefNum;				//indicate target volume
		myPB.dirInfo.ioDrDirID = reply.sfFile.parID;				//initialize parent directory ID
		myPB.dirInfo.ioFDirIndex = -1;								//get info about a directory
		//Get name of each parent directory, up to root directory.	
		do
			{
			oserr = PBGetCatInfo(&myPB, FALSE);
			myPB.dirInfo.ioDrDirID = myPB.dirInfo.ioDrParID;
			p2cstr((unsigned char *)dirName);
			strcat(dirName, ":");
			strcpy(temp, dirName);
			strcat(temp, fullPath);
			strcpy(fullPath, temp);
			}
		while (myPB.dirInfo.ioDrDirID != fsRtDirID && oserr >= 0);
		
		if (oserr < 0)
			Fail(0);
		
		SetVol(NULL, reply.sfFile.vRefNum);
		strcpy(temp, fullPath);
		GetVol((unsigned char *)fullPath, (short*)&n);
		p2cstr((unsigned char *)fullPath);
		strcat(fullPath, ":");
		strcat(fullPath, temp);
		}
	pAAM->Load(fullPath);
	}
/******************************************************************************
 ContentsToWindow
 
 	Make window reflect document's contents.  If the document does
 	not use a file, this function is never called and may be deleted.
******************************************************************************/
void CMain::ContentsToWindow()
	{
		// Transfer data from itsContents to itsWindow.
		// See Chapter 11, Using Object I/O
	}
/******************************************************************************
 WindowToContents
 
 	Make document's contents reflect window's contents (if they
 	don't already).  If the document does not use a file, this
 	function is never called and may be deleted.
******************************************************************************/
void CMain::WindowToContents()
	{
		// Transfer data from itsWindow to itsContents
	}
void CMain::DoCmdViewTraining()
	{
	switch (bViewTraining)
		{
		case FALSE:										// Respond to command by opening a window
			pViewTraining = TCL_NEW(CViewFaces,());
			pViewTraining->ICViewFaces(this);
			pViewTraining->SetFaceDB(pAAM->GetTrainingDB());
														/* Put the face database in the window */
			pViewTraining->itsWindow->Select();			/* Bring window to the front and run	*/
			bViewTraining = TRUE;
			break;
			
		case TRUE:
			/*delete*/ TCLForgetObject(pViewTraining);
			pViewTraining = NULL;
			bViewTraining = FALSE;
			break;
		}
	}
void CMain::DoCmdViewEigen()
	{
	switch (bViewEigen)
		{
		case FALSE:										// Respond to command by opening a window
			pViewEigen = TCL_NEW(CViewFaces, ());
			pViewEigen->ICViewFaces(this);
			pViewEigen->SetFaceDB(pAAM->GetEigenDB());	
														/* Put the face database in the window */
			pViewEigen->itsWindow->Select();			/* Bring window to the front and run	*/
			bViewEigen = TRUE;
			break;
			
		case TRUE:
			/*delete*/ TCLForgetObject(pViewEigen);
			pViewEigen = NULL;
			bViewEigen = FALSE;
			break;
		}
	}
void CMain::DoCmdViewReconstruction()
	{
	switch (bViewReconstruction)
		{
		case FALSE:										// Respond to command by opening a window
			pViewReconstruction = TCL_NEW(CViewReconstruction, ());
			pViewReconstruction->ICViewReconstruction(this);
			pViewReconstruction->SetFaceDB(pAAM->GetReconstructionDB(), pAAM->GetReconstructedDB());	
														/* Put the face database in the window */
			pViewReconstruction->itsWindow->Select();	/* Bring window to the front and run */
			bViewReconstruction = TRUE;
			break;
			
		case TRUE:
			/*delete*/ TCLForgetObject(pViewReconstruction);
			pViewReconstruction = NULL;
			bViewReconstruction = FALSE;
			break;
		}
	}
void CMain::DoCmdViewRecognition()
	{
	switch (bViewRecognition)
		{
		case FALSE:										// Respond to command by opening a window
			pViewRecognition = TCL_NEW(CViewReconstruction, ());
			pViewRecognition->ICViewReconstruction(this);
			pViewRecognition->SetFaceDB(pAAM->GetRecognitionDB(), pAAM->GetRecognizedDB());	
														/* Put the face database in the window */			pViewRecognition->itsWindow->Select();		/* Bring window to the front and run */
			bViewRecognition = TRUE;
			break;
			
		case TRUE:
			/*delete*/ TCLForgetObject(pViewRecognition);
			pViewRecognition = NULL;
			bViewRecognition = FALSE;
			break;
		}
	}
/******************************************************************************
 UpdateMenus {OVERRIDE}
		Enable menus which generate commands handled by this class.
 ******************************************************************************/
void CMain::UpdateMenus()
	{
	x_CMain::UpdateMenus();
	
	if (pAAM->IsCommand(CMD_TRAINING) == TRUE)
		{
		if (bViewTraining == TRUE)
			gBartender->CheckMarkCmd(cmdViewTraining, TRUE);	//Place a check mark
		else
			gBartender->CheckMarkCmd(cmdViewTraining, FALSE);	//Remove the check mark
		}
	else
		gBartender->DisableCmd(cmdViewTraining);				//Disable the command
		
	if (pAAM->IsCommand(CMD_TRAINING) == TRUE || pAAM->IsCommand(CMD_LOAD_EIGEN) == TRUE)
		{
		if (bViewEigen == TRUE)
			gBartender->CheckMarkCmd(cmdViewEigen, TRUE);		//Place a check mark
		else
			gBartender->CheckMarkCmd(cmdViewEigen, FALSE);		//Remove the check mark
		}
	else
		gBartender->DisableCmd(cmdViewEigen);					//Disable the command
	
	if (pAAM->IsCommand(CMD_RECONSTRUCTION) == TRUE)
		{
		if (bViewReconstruction == TRUE)
			gBartender->CheckMarkCmd(cmdViewReconstruction, TRUE);		//Place a check mark
		else
			gBartender->CheckMarkCmd(cmdViewReconstruction, FALSE);		//Remove the check mark
		}
	else
		gBartender->DisableCmd(cmdViewReconstruction);					//Disable the command
	
	if (pAAM->IsCommand(CMD_RECOGNIZE) == TRUE)
		{
		if (bViewRecognition == TRUE)
			gBartender->CheckMarkCmd(cmdViewRecognition, TRUE);			//Place a check mark
		else
			gBartender->CheckMarkCmd(cmdViewRecognition, FALSE);		//Remove the check mark
		}
	else
		gBartender->DisableCmd(cmdViewRecognition);				//Disable the command
	}
void CMain::SetMsg(char *str)
	{
	pMainStat->AppendMsg(str);
	
	/*Gives the opportunity to display the message in its window and to the other application*/
	/* to run. Drawback : slow down the process*/
	/*WaitNextEvent(0, &Event, 1000, NULL);*/
	gApplication->Process1Event();
	}
int CMain::SaveReport(char *filename)
	{
	return pMainStat->Save(filename);
	}
