/******************************************************************************
 CViewFaces.cp
				CViewFaces Window Director Class
	
	Copyright  1996 Sami Romdhani 1996. All rights reserved.
	Generated by Visual Architect 1:46 pm Sat, Jan 27, 1996
	This file is only generated once. You can modify it by filling
	in the placeholder functions and adding any new functions you wish.
	If you change the name of the document class, a fresh version of this
	file will be generated. If you have made any changes to the file
	with the old name, you will have to copy those changes to the new
	file by hand.
 ******************************************************************************/

#include "CViewFaces.h"
#include "utilcpp.h"
#include "ViewFacesItems.h"
#include <CApplication.h>
#include <Constants.h>
#include <CDecorator.h>
#include <CDesktop.h>
#include <CDirectorOwner.h>
#include <CFile.h>
#include <TBUtilities.h>
#include <CWindow.h>

extern	CApplication *gApplication;		/* The application					*/
extern CDecorator	*gDecorator;		/* Decorator for arranging windows	*/
extern CDesktop		*gDesktop;			/* The visible Desktop				*/

TCL_DEFINE_CLASS_M1(CViewFaces, x_CViewFaces);

/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/
CViewFaces::~CViewFaces()
	{
	/*TCL_START_DESTRUCTOR*/
	
	if (pDrawPane != NULL)
		{
		/*TCLForgetObject(*/delete pDrawPane;
		}
	}

/******************************************************************************
 ICViewFaces
	Initialize the dialog. Directors are not stored in view resources,
	so this method *is* called to initialize the director. Change
	the code as indicated to perform your own initialization.
 ******************************************************************************/
void CViewFaces::ICViewFaces(CDirectorOwner *aSupervisor)
	{
		// Initialize data members here that must be set up
		// before BeginData is called
		// We use the inherited keyword because of a C++
		// compiler bug involving _classname::. This will be
		// changed when the compiler is fixed.
	x_CViewFaces::Ix_CViewFaces(aSupervisor);
		// Initialize any other data members here
	pFaceDB = 0;
	pFaceMat = 0;
	bMat = FALSE;
	}

/******************************************************************************
 ProviderChanged	{OVERRIDE}
 	
 	A pane changed value
******************************************************************************/
void CViewFaces::ProviderChanged(CCollaborator *aProvider, long reason, void* info)
{
#define DO_NOTHING
	if (ignore)						// Honor ignore flag set by superclass
		return;
	ignore = TRUE;					// Don't enter recursively
	
		//	Override this function if you need to respond to
		//	changes in pane values.
	TRY
	{
		if (FALSE)
			DO_NOTHING;
			
			//	Insert your cases here. They should look like:
		
			//	else if (reason == rrr && aProvider == fxxx_xxx)
			//	{
			//		do something
			//	}
	
			//	Note that there is a lot of traffic through this function
			//	in addition to value changes. Do not forget to call the
			//	superclass for all changes you do not handle completely.
	
		else
			x_CViewFaces::ProviderChanged(aProvider, reason, info);
	}
	CATCH
		ignore = FALSE;
	ENDTRY
	
	ignore = FALSE;
}
/******************************************************************************
 DoCommand {OVERRIDE}
		Dispatch commands
 ******************************************************************************/
void CViewFaces::DoCommand(long theCommand)
{
	switch (theCommand)
	{
			// Insert your command handler cases here, e.g.,
			//
			//	case cmdMine:
			//		DoMyCmd();
			//		break;
		default:
			x_CViewFaces::DoCommand(theCommand);
	}
}
/*****************************************************************************
* SetFaceDB initialise the face database data (pFaceDB) as long with other parameters
* like xNum, yNum, lastNum. It also puts the right dimension of the pane
******************************************************************************/
void CViewFaces::SetFaceDB(CFaceDB *pFaceDBt)
	{
	bMat = FALSE;
	pFaceDB = pFaceDBt;
	pDrawPane->SetFaceDB(pFaceDB);
	
	Start();
	}
	
void CViewFaces::SetFaceDB(CMatrix *pFaceMatt, CDiag *pEigenValt)
	{
	bMat = TRUE;
	pFaceMat = pFaceMatt;
	pEigenVal = pEigenValt;
	pDrawPane->SetFaceDB(pFaceMat, pEigenVal);
	
	Start();
	}
	
void CViewFaces::Start()
	{		
	Rect delta;
	LongRect lr;
	GEOMPARAMS GeomParams;
	int LastLine = 0;
	
	/*Sets the right pane's dimensions. It must be able to contain all the faces in the database*/
	pDrawPane->GetGeomParams(&GeomParams);
	
	lr.top = 0;
	lr.left = 0;
	if (GeomParams.lastNum > 0)
		LastLine = 1;
	else
		LastLine = 0;
	lr.bottom = pDrawPane->Getylen()*(GeomParams.yNum + LastLine);
	lr.right = pDrawPane->Getxlen()*GeomParams.xNum;
	pDrawPane->SetBounds(&lr);
	pDrawPane->FitToEnclosure(TRUE, TRUE);
	pScrollP->InstallPanorama((CPanorama*)pDrawPane);
	pDrawPane->SetScrollPane(pScrollP);
	}
/******************************************************************************
 MakeNewWindow
	Create a window by reading a view resource
 ******************************************************************************/
void CViewFaces::MakeNewWindow(void)
	{
	x_CViewFaces::MakeNewWindow();
	
	pScrollP = new CScrollPane((CView*)itsWindow, (CBureaucrat*)this, 150, 150, 0, 0, sizELASTIC, sizELASTIC, TRUE, TRUE, TRUE);
	pScrollP->FitToEnclosure(TRUE, TRUE);
	pDrawPane = /*TCL_NEW(*/new CDrawFace((CView*)pScrollP, (CBureaucrat*)this);
													/*Construct the pane*/
	}
