#ifndef CFaceDB_H
#define CFaceDB_H

#include "CFace.h"
#include "CDiag.h"
#include "CMatPtr.h"

class CFaceDB
	{
	private:
		long 			nNumFace;							/*Number of faces in the data base*/
		long 			xlen, ylen;							/*dimension of each face*/
		CObArray 	*pArray;								/*Actual array of CFace objects, template of CPtrArray*/
	
	public:
		CFaceDB();
		~CFaceDB();
		
		int 			Load(char *file);
		int 			AddFace(char *file);
		int 			Save(char *str_dir);
		int 			Copy(CMatrixPtr *pMat, CDiag *pDiag);
		
		long 			Getxlen();
		long 			Getylen();
		long 			GetNumPixel();
		long 			GetNumFace();
		CFace 		*GetFace(int l);
		typeface 	*GetFaceData(int l);
		CMemory 		*GetFaceMem(int l);
		char 			*GetFaceName(int l);
		void 			ReleaseFaceData(int l);
		void 			Expand(int nFace, float *scale, float *shift, float src_min, float src_max);
		
	private:
		int 			GetStr(char *str_temp, char *aName, int lenaName, char *Delimit);
		long 			GetLong(char *str_temp);
		int 			GetLine(char *str_temp, char *FileName, int lenFileName, char *FaceName, int lenFaceName);
	}; 
	
#endif /* CFaceDB_H */
